/*
Build by Wiquid's PCI Generator for TAO platform Free to use 
 */
define([
    'taoQtiItem/qtiCreator/widgets/states/factory',
    'taoQtiItem/qtiCreator/widgets/interactions/states/Question',
    'taoQtiItem/qtiCreator/widgets/helpers/formElement',
    'taoQtiItem/qtiCreator/editor/simpleContentEditableElement',
    'taoQtiItem/qtiCreator/editor/containerEditor',
    'tpl!EtherCalc/creator/tpl/propertiesForm',
    'lodash',
    'jquery'
], function (stateFactory, Question, formElement, simpleEditor, containerEditor, formTpl, _, $) {
    'use strict';

    var EtherCalcStateQuestion = stateFactory.extend(Question, function () {

        var Scontainer = this.widget.$container,
            Sprompt = Scontainer.find('.prompt'),
            interaction = this.widget.element;

        containerEditor.create(Sprompt, {
            change: function (text) {
                interaction.data('prompt', text);
                interaction.updateMarkup();
            },
            markup: interaction.markup,
            markupSelector: '.prompt',
            related: interaction
        });


    }, function () {
        var Scontainer = this.widget.$container,
            Sprompt = Scontainer.find('.prompt');
        simpleEditor.destroy(Scontainer);
        containerEditor.destroy(Sprompt);
    });

    EtherCalcStateQuestion.prototype.initForm = function () {

        

        var _widget = this.widget,
            Sform = _widget.$form,
            interaction = _widget.element,
            response = interaction.getResponseDeclaration(),
            level = interaction.prop('level') || 'visible',
            levels = ['visible', 'not visible'],
            levelData = {},
            btTools = ["sc_undo", "sc_redo", "sc_copy", "sc_cut", "sc_paste", "sc_delete", "sc_formatpaintbrush", "sc_lock", "sc_unlock", "sc_filldown", "sc_fillright", "sc_alignleft", "sc_aligncenter", "sc_alignright", "sc_borderson", "sc_bordersoff", "sc_swapcolors", "sc_mergecells", "sc_insertrows", "sc_insertcolumns", "sc_deleterows", "sc_deletecolumns", "sc_hiderow", "sc_hidecol", "sc_autosum", "sc_movefromoff", "sc_movepaste", "sc_movepasteoff", "sc_moveinsert", "sc_moveinsertoff", "chart-area", "chart-bar", "chart-line", "chart-pie", "chart-polar", "chart-ring", "chart-scatter", "sc_insertformula", "sc_listbox", "sc_inserthyperlink", "sc_autosum"],
            btToolData = {},
            Tounchecked = interaction.prop('hiddenBt');
        //build select option data for the template
        _.each(levels, function (lvl) {
            levelData[lvl] = {
                label: lvl,
                selected: (lvl === level)
            };
        });

        _.each(btTools, function (lvl) {
            
            if (typeof Tounchecked != 'undefined') {
                if (!Tounchecked==={}) {
                    //Case found
                    btToolData[lvl] = {
                        label: lvl,
                        selected: lvl,
                        checked: false
                    }

                } else {
                    // case not found
                    btToolData[lvl] = {
                        label: lvl,
                        selected: lvl,
                        checked: true
                    }
                };


                for (let i = 0; i < Tounchecked.length; i++) {
                    Sform.find("." + Tounchecked[i]).prop("checked", false);
                }
            }
        });

        //render the form using the form template
        Sform.html(formTpl({
            serial: response.serial,
            levels: levelData,
            tools: btToolData,
            identifier: interaction.attr('responseIdentifier')
        }));






        //init form javascript
        formElement.initWidget(Sform);
        



        var bt2hide = [],
            btName;
        Sform.find(".hideme").on("click", function () {

            btName = $(this).attr("name")
            if ($(this).prop('checked')) {
                //On vérifie dans le array et si présent on l'enlève
                for (let i = 0; i < bt2hide.length; i++) {
                    
                    if (bt2hide.indexOf(bt2hide[i]) >= 0) {
                        
                        bt2hide.splice(i, 1);
                    }
                }
            } else {
               
                if (bt2hide.indexOf(btName) < 0) {
                    bt2hide.push(btName);
                }
            }

            interaction.prop('hiddenBt', bt2hide);
            interaction.triggerPci('hiddenBtchange', bt2hide);
            
            $(".EtherCalc .sprite").show();
            for (let i = 0; i < bt2hide.length; i++) {
                $(".EtherCalc  ." + bt2hide[i]).hide();
            }

        });


        //init data change callbacks
        formElement.setChangeCallbacks(Sform, interaction, {
            level: function level(interaction, value) {
                //update the pci property value:
                interaction.prop('level', value);
                //trigger change event:
                interaction.triggerPci('levelchange', [value]);
            },
            identifier: function (i, value) {
                response.id(value);
                interaction.attr('responseIdentifier', value);
            }
        });



    };



    return EtherCalcStateQuestion;
});